<?php
// check-ad-ldap.php version 1.0.1
// Created by JATUPORN CHUCHUAY 2557-08-27
// updated by JATUPORN 2559-02-25
// updated by WIBOON 2559-04-08 set default to openldap example.com

// Default Config
// Server ldap type : "activedirectory" or "openldap"
// $servertype = "activedirectory";
$servertype = "openldap";

// --- Example : OpenLdap example.com
$server = array("ldap.example.com");
// --- Example : LDAPS on Microsoft AD ---
//$server = array("ad1.xx.yy.zz","ad2.xx.yy.zz","ad3.xx.yy.zz");

// Base OU for search all user

// Note : $basedn can support multiple ou with array list etc. array(ou1,ou2,ou3)

// --- Example : OpenLdap example.com
$basedn = "dc=example,dc=com";
$domain = "example.com";

// --- Example : Your AD domain
// $basedn = "dc=xx,dc=yy,dc=zz";
// $domain = "xx.yy.zz";

// Get Username & Password from linux command line
$username=$argv[1];
$password=$argv[2];

// If have third argument -> Filter OU with specific IP (Define user group for access)
if(isset($argv[3])){
        if($argv[3]=="127.0.0.1"){
		// --- Example : OpenLdap with some OU Only ---
                //$searchdn = array("ou=staffs,ou=groups,dc=example,dc=com");
		// or all
                $searchdn = array("dc=example,dc=com");

		// --- Example : AD with ou=students Only --
		//$searchdn = array("ou=students,dc=xx,dc=yy,dc=zz");
		// --- Example : AD with ou=staffs Only --
		//$searchdn = array("ou=staffs,dc=xx,dc=yy,dc=zz");
		// --- Example : AD with staffs and students --
		//$searchdn = array("ou=staffs,dc=xx,dc=yy,dc=zz","ou=students,dc=xx,dc=yy,dc=zz");
		// --- Example : or All --
		//$searchdn = array("dc=xx,dc=yy,dc=zz");
        }
//No Filter
}else{
	$searchdn[0] = $basedn;
}

function authenticate($servertype,$server,$basedn,$searchdn,$domain,$username,$password){
	// Define boolean default value
        $auth_status = false;
        $ou_check = false;
	
        $i=0;
        if(trim($password)<>""){
                while(($i<count($server))&&($auth_status==false)){
			$ldap_connect = true;
			$bind_dn = true;
			$bind_info = true;
			// Ldap connect
                        $ldap = @ldap_connect("ldaps://".$server[$i]) or $ldap_connect = false;
                        ldap_set_option($ldap, LDAP_OPT_REFERRALS, 0);
                        ldap_set_option($ldap, LDAP_OPT_PROTOCOL_VERSION, 3);

			if($ldap_connect == true){
				// Anonymous bind
                        	$ldapbind = @ldap_bind($ldap) or $bind_dn = false;
				if($bind_dn == true){
					// Search DN
					if($servertype=="openldap"){
                                		$sd=ldap_search($ldap, $basedn, "uid=".$username, array("dn"));
                                	}else{
						$ldapbind = @ldap_bind($ldap, $username."@".$domain, $password) or $bind_info = false;
                                		$sd=ldap_search($ldap, $basedn, "userPrincipalName=".$username."@".$domain,array("dn"));
						//Special for your AD
                                		$sdextra=ldap_search($ldap, $basedn, "userPrincipalName=".$username."@ww.xx.yy.zz",array("dn"));
						//End Special for your AD
                                	}	
					$dninfo = ldap_get_entries($ldap,$sd);
					//Special for your AD
					if(!isset($dninfo[0]['dn'])){
						unset($dninfo);
						$dninfo = ldap_get_entries($ldap,$sdextra);
					}
					//End Special for your AD
					// User found in ldap account
					if(isset($dninfo[0]['dn'])){
						$dn = $dninfo[0]['dn'];
						// Check condition filter OU with specific IP
						// Authentication Bind with filter OU
						if($servertype=="openldap"){
							$ldapbind = @ldap_bind($ldap,$dn,$password) or $bind_info = false;
						}
						if($bind_info == true){
                                			$j=0;
                                			while(($j<count($searchdn))&&($ou_check==false)){
								if($servertype=="openldap"){
                                       					$sr=@ldap_search($ldap, $searchdn[$j], "uid=".$username, array("dn"));
								}else{
                                       					$sr=@ldap_search($ldap, $searchdn[$j], "(&(objectClass=user)(objectCategory=person)(samaccountname=".$username."))",array("dn"));
								}
                                       				$info = @ldap_get_entries($ldap, $sr);
                                       				if(isset($info[0]["dn"])){
                                       					$ou_check = true;
                                       				}else{
                                      					$ou_check = false;
                                       				}
                                       				unset($info);
                                       				$j++;
							}
							if($ou_check==true){
                                      				$auth_status = true;
                                       			}else{
                                      				$auth_status = false;
                                			}
                               			}
					}
					unset($dninfo);
				}
			}
                	ldap_close($ldap);
                	$i++;
                }
        }
        return $auth_status;
}

// Call authenticate function
$authen = authenticate($servertype,$server,$basedn,$searchdn,$domain,$username,$password);
if($authen==true){
        echo "true";
}else{
        echo "false";
}
?>

